Bug 494073 - Review Request: libvmime - Powerful library for MIME messages and Internet messaging services
Review Request: libvmime - Powerful library for MIME messages and Internet me...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert Scheck
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-03 21:13 EDT by Jeroen van Meeuwen
Modified: 2009-05-08 23:59 EDT (History)
2 users (show)

See Also:
Fixed In Version: 0.9.0-3.fc11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-04-27 17:27:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
redhat: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jeroen van Meeuwen 2009-04-03 21:13:07 EDT
Spec URL: http://www.kanarip.com/custom/SPECS/libvmime.spec
SRPM URL: http://www.kanarip.com/custom/f11/SRPMS/libvmime-0.9.0-1.fc11.src.rpm
Description:
VMime is a powerful C++ class library for working with MIME messages
and Internet messaging services like IMAP, POP or SMTP.

With VMime you can parse, generate and modify messages, and also
connect to store and transport services to receive or send messages
over the Internet. The library offers all the features to build a
complete mail client.

rpmlint is silent

- f9: http://koji.fedoraproject.org/koji/taskinfo?taskID=1276553 (fails because of dependency error)
- f9: http://koji.fedoraproject.org/koji/taskinfo?taskID=1276589 (succeeds without inkscape builddep)
- f10: http://koji.fedoraproject.org/koji/taskinfo?taskID=1276554
- f11: http://koji.fedoraproject.org/koji/taskinfo?taskID=1276559

A note on the inkscape builddep; if I were to package the documentation I would need inkscape to generate the pdf from the *.tex files, though I'm not sure that I should (the docs don't build for a normal ./configure && make either)
Comment 1 Michael Schwendt 2009-04-08 07:47:44 EDT
* Most certainly you want the -static subpackage to require the -devel subpackage instead of the main package.


> %doc AUTHORS COPYING ChangeLog INSTALL README

In case this is the standard "INSTALL" file, it is irrelevant to RPM package users and typically is not included.


* Further, is it necessary to include the same %doc files in all three packages? They are stored in three different doc directories.


* The pkgconfig file is tuned for static linking and relinks against libgsasl and libgnutls. If you keep it like that, you're missing dependencies in the -devel package for the corresponding -devel pkgs that contain those lib symlinks:

$ cat vmime.pc|grep l[ib]*g
Requires: libgsasl
Libs: -L${libdir} -lvmime -lgsasl -lgnutls 

$ rpm -qpR libvmime-0.9.0-1.fc10.x86_64.rpm |grep ^libg
libgcc_s.so.1()(64bit)  
libgcc_s.so.1(GCC_3.0)(64bit)  
libgnutls.so.26()(64bit)  
libgnutls.so.26(GNUTLS_1_4)(64bit)  
libgsasl.so.7()(64bit)
Comment 2 Robert Scheck 2009-04-13 19:27:23 EDT
Any news here?
Comment 3 Jeroen van Meeuwen 2009-04-14 00:12:07 EDT
I've taken Michael's suggestions:

New SPEC: http://www.kanarip.com/custom/SPECS/libvmime.spec
New SRPM: http://www.kanarip.com/custom/f11/SRPMS/libvmime-0.9.0-2.fc11.src.rpm
Comment 4 Robert Scheck 2009-04-14 10:11:51 EDT
- Why do you %doc INSTALL? Doesn't make much sense to me.
- To me it looks like the $RPM_OPT_FLAGS are not honored, following seems to
  work for me so far and uses also parallel builds:
  > export EXTRA_CFLAGS="$RPM_OPT_FLAGS"
  > %configure
  > make %{?_smp_mflags}
- Is there really any need to ship the static libraries? So shouldn't link 
  anything in Fedora anyway dynamically?
- Group "Applications/System"? Wouldn't "System Environment/Libraries" be a
  bit better?
- Regarding the documentation: Did you have a closer look to it, whether that
  one is usable and it's not just a waste of disk space?
- Source0 should be like http://fedoraproject.org/wiki/Packaging/SourceURL;
  use: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2

[ DONE ] MUST: rpmlint must be run on every package
         $ rpmlint /var/lib/mock/fedora-rawhide-x86_64/result/libvmime-*
         libvmime-devel.x86_64: W: no-documentation
         libvmime-static.x86_64: W: no-documentation
         5 packages and 0 specfiles checked; 0 errors, 2 warnings.
         $
         -> Okay and accepted according to comment #2
[  OK  ] MUST: The package must be named according to the Package Naming 
         Guidelines
[  OK  ] MUST: The spec file name must match the base package %{name} [...]
[  ??  ] MUST: The package must meet the Packaging Guidelines
         -> See above.
[  OK  ] MUST: The package must be licensed with a Fedora approved license
         and meet the Licensing Guidelines
[  OK  ] MUST: The License field in the package spec file must match the 
         actual license
[  OK  ] MUST: If (and only if) the source package includes the text of the 
         license(s) in its own file, then that file, containing the text of 
         the license(s) for the package must be included in %doc
[  OK  ] MUST: The spec file must be written in American English.
[  OK  ] MUST: The spec file for the package MUST be legible.
[  OK  ] MUST: The sources used to build the package must match the upstream 
         source, as provided in the spec URL. Reviewers should use md5sum for 
         this task. If no upstream URL can be specified for this package, 
         please see the Source URL Guidelines for how to deal with this.
         -> 23feb9cff7ba3961c0693926e21448cf  libvmime-0.9.0.tar.bz2
         -> 23feb9cff7ba3961c0693926e21448cf  libvmime-0.9.0.tar.bz2.1
         -> 02215e1d8ea758f486c32e7bff63a04f71a9b736  libvmime-0.9.0.tar.bz2
         -> 02215e1d8ea758f486c32e7bff63a04f71a9b736  libvmime-0.9.0.tar.bz2.1
[  OK  ] MUST: The package MUST successfully compile and build into binary 
         rpms on at least one primary architecture
[  N/A ] MUST: If the package does not successfully compile, build or work on 
         an architecture, then those architectures should be listed in the 
         spec in ExcludeArch. Each architecture listed in ExcludeArch MUST 
         have a bug filed in bugzilla, describing the reason that the package 
         does not compile/build/work on that architecture. The bug number MUST 
         be placed in a comment, next to the corresponding ExcludeArch line
[  ??  ] MUST: All build dependencies must be listed in BuildRequires, except 
         for any that are listed in the exceptions section of the Packaging 
         Guidelines ; inclusion of those as BuildRequires is optional. Apply 
         common sense.
         -> See above (documentation related).
[  N/A ] MUST: The spec file MUST handle locales properly. This is done by 
         using the %find_lang macro. Using %{_datadir}/locale/* is strictly 
         forbidden
[  OK  ] MUST: Every binary RPM package (or subpackage) which stores shared 
         library files (not just symlinks) in any of the dynamic linker's 
         default paths, must call ldconfig in %post and %postun. [10]
[  N/A ] MUST: If the package is designed to be relocatable, the packager must 
         state this fact in the request for review, along with the 
         rationalization for relocation of that specific package. Without 
         this, use of Prefix: /usr is considered a blocker. [11]
[  OK  ] MUST: A package must own all directories that it creates. If it does 
         not create a directory that it uses, then it should require a package 
         which does create that directory.
[  OK  ] MUST: A package must not contain any duplicate files in the %files 
         listing.
[  OK  ] MUST: Permissions on files must be set properly. Executables should 
         be set with executable permissions, for example. Every %files section 
         must include a %defattr(...) line.
[  OK  ] MUST: Each package must have a %clean section, which contains rm -rf
         %{buildroot} (or $RPM_BUILD_ROOT).
[  OK  ] MUST: Each package must consistently use macros.
[  OK  ] MUST: The package must contain code, or permissable content.
[  ??  ] MUST: Large documentation files must go in a -doc subpackage. (The 
         definition of large is left up to the packager's best judgement, but 
         is not restricted to size. Large can refer to either size or 
         quantity).
         -> See above (documentation related).
[  ??  ] MUST: If a package includes something as %doc, it must not affect the 
         runtime of the application. To summarize: If it is in %doc, the 
         program must run properly if it is not present.
         -> See above (documentation related).
[  OK  ] MUST: Header files must be in a -devel package.
[  OK  ] MUST: Static libraries must be in a -static package.
         -> Is the -static subpackage really needed and wanted?
[  OK  ] MUST: Packages containing pkgconfig(.pc) files must 'Requires: 
         pkgconfig' (for directory ownership and usability).
[  OK  ] MUST: If a package contains library files with a suffix (e.g. 
         libfoo.so.1.1), then library files that end in .so (without suffix) 
         must go in a -devel package.
[  OK  ] MUST: In the vast majority of cases, devel packages must require the 
         base package using a fully versioned dependency: Requires: %{name} =
         %{version}-%{release}
[  OK  ] MUST: Packages must NOT contain any .la libtool archives, these must 
         be removed in the spec if they are built.
[  N/A ] MUST: Packages containing GUI applications must include a
         %{name}.desktop file, and that file must be properly installed with 
         desktop-file-install in the %install section. If you feel that your 
         packaged GUI application does not need a .desktop file, you must put 
         a comment in the spec file with your explanation.
[  OK  ] MUST: Packages must not own files or directories already owned by 
         other packages. The rule of thumb here is that the first package to 
         be installed should own the files or directories that other packages 
         may rely upon. This means, for example, that no package in Fedora 
         should ever share ownership with any of the files or directories 
         owned by the filesystem or man package. If you feel that you have a 
         good reason to own a file or directory that another package owns, 
         then please present that at package review time.
[  OK  ] MUST: At the beginning of %install, each package MUST run rm -rf
         %{buildroot} (or $RPM_BUILD_ROOT).
[  OK  ] MUST: All filenames in rpm packages must be valid UTF-8.

Maybe let us short discuss about the documentation, that's the only real point
of the review, where some time needs to be spend for now. Rest of my points is
(or should) be trivial so far.
Comment 5 Robert Scheck 2009-04-14 10:13:04 EDT
Ah, one thing I forgot: %configure is looking for /usr/sbin/sendmail - so it
could make sense to buildrequire sendmail package to ensure that dependency
and the resulting build features.
Comment 6 Jeroen van Meeuwen 2009-04-17 06:12:42 EDT
(In reply to comment #4)
> - Why do you %doc INSTALL? Doesn't make much sense to me.

It does make sense to me as it is upstream %doc and so I ship it but it's not a big deal.

> - To me it looks like the $RPM_OPT_FLAGS are not honored, following seems to
>   work for me so far and uses also parallel builds:
>   > export EXTRA_CFLAGS="$RPM_OPT_FLAGS"
>   > %configure
>   > make %{?_smp_mflags}

Fixed.

> - Is there really any need to ship the static libraries? So shouldn't link 
>   anything in Fedora anyway dynamically?

This is a dependency for ISV products I'm packaging.

> - Group "Applications/System"? Wouldn't "System Environment/Libraries" be a
>   bit better?

You're right. Fixed.

> - Regarding the documentation: Did you have a closer look to it, whether that
>   one is usable and it's not just a waste of disk space?

As discussed on IRC, no detailed docs are shipped and are available online. I added a comment to the spec file to reflect that.

> - Source0 should be like http://fedoraproject.org/wiki/Packaging/SourceURL;
>   use: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2
> 

Fixed.

New SPEC: http://www.kanarip.com/custom/SPECS/libvmime.spec
New SRPM: http://www.kanarip.com/custom/f11/SRPMS/libvmime-0.9.0-3.fc11.src.rpm
Comment 7 Robert Scheck 2009-04-17 06:29:03 EDT
Thanks for performing the changes, everything is fine now and looks good,
thus the package is: APPROVED.
Comment 8 Jeroen van Meeuwen 2009-04-17 07:14:44 EDT
New Package CVS Request
=======================
Package Name: libvmime
Short Description: Library for MIME messages and Internet messaging services
Owners: kanarip
Branches: EL-4 EL-5 F-9 F-10
InitialCC:
Comment 9 Robert Scheck 2009-04-17 07:24:09 EDT
You may want to add F-11 as well, because devel/Rawhide is already dist-f12...
Comment 10 Kevin Fenzi 2009-04-17 17:33:00 EDT
cvs done.
Comment 11 Robert Scheck 2009-04-22 13:37:33 EDT
Ping Jeroen?
Comment 12 Fedora Update System 2009-04-23 12:15:19 EDT
libvmime-0.9.0-3.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/libvmime-0.9.0-3.fc9
Comment 13 Fedora Update System 2009-04-23 12:15:25 EDT
libvmime-0.9.0-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/libvmime-0.9.0-3.fc11
Comment 14 Fedora Update System 2009-04-23 12:15:31 EDT
libvmime-0.9.0-3.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/libvmime-0.9.0-3.fc10
Comment 15 Fedora Update System 2009-04-27 17:27:16 EDT
libvmime-0.9.0-3.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2009-04-27 17:41:01 EDT
libvmime-0.9.0-3.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2009-05-08 23:59:00 EDT
libvmime-0.9.0-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.